"""
    Blockdaemon REST API

    Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet/testnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ubiquity.ubiquity_openapi_client.api_client import ApiClient, Endpoint as _Endpoint
from ubiquity.ubiquity_openapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from ubiquity.ubiquity_openapi_client.model.block import Block
from ubiquity.ubiquity_openapi_client.model.block_identifier import BlockIdentifier
from ubiquity.ubiquity_openapi_client.model.block_identifiers import BlockIdentifiers
from ubiquity.ubiquity_openapi_client.model.error import Error


class BlocksApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __get_block_by_number(
            self,
            protocol="bitcoin",
            network="mainnet",
            block_identifier="0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959",
            **kwargs
        ):
            """Get a Block by Number or Hash  # noqa: E501

            Get a block and all its transactions by a user-defined block number or block hash.   Use `-1` or `current` parameter to return the current block.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_block_by_number(protocol="bitcoin", network="mainnet", block_identifier="0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                block_identifier (str): The block identifier, hash or number.. defaults to "0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959", must be one of ["0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Block
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['block_identifier'] = \
                block_identifier
            return self.call_with_http_info(**kwargs)

        self.get_block_by_number = _Endpoint(
            settings={
                'response_type': (Block,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/block/{block_identifier}',
                'operation_id': 'get_block_by_number',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'block_identifier',
                ],
                'required': [
                    'protocol',
                    'network',
                    'block_identifier',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'block_identifier':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'block_identifier': 'block_identifier',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'block_identifier': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_block_by_number
        )

        def __get_block_identifier_by_number(
            self,
            protocol="bitcoin",
            network="mainnet",
            block_identifier="0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959",
            **kwargs
        ):
            """Get a Block Identifier by Number of Hash  # noqa: E501

            Get the minimal block data, block header, by a user-defined block number or block hash.   Use `-1` or `current` parameter to return the current block.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_block_identifier_by_number(protocol="bitcoin", network="mainnet", block_identifier="0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                block_identifier (str): The block identifier, hash or number.. defaults to "0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959", must be one of ["0000000000000000000590fc0f3eba193a278534220b2b37e9849e1a770ca959"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                BlockIdentifier
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['block_identifier'] = \
                block_identifier
            return self.call_with_http_info(**kwargs)

        self.get_block_identifier_by_number = _Endpoint(
            settings={
                'response_type': (BlockIdentifier,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/block_identifier/{block_identifier}',
                'operation_id': 'get_block_identifier_by_number',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'block_identifier',
                ],
                'required': [
                    'protocol',
                    'network',
                    'block_identifier',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'block_identifier':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'block_identifier': 'block_identifier',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'block_identifier': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_block_identifier_by_number
        )

        def __get_block_identifiers(
            self,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Get a List of Block Identifiers  # noqa: E501

            Returns a list of minimal block data, block headers such as block hash and block number.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_block_identifiers(protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `optimism`, `polkadot`, `polygon`, `tezos`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                order (str): The pagination order.. [optional] if omitted the server will use the default value of "desc"
                page_token (str): The token to retrieve more items in the next request. Use the `next_page_token` returned from the previous response for this parameter.. [optional]
                page_size (int): Max number of items to return in a response. Defaults to 25 and is capped at 100. . [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                BlockIdentifiers
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            return self.call_with_http_info(**kwargs)

        self.get_block_identifiers = _Endpoint(
            settings={
                'response_type': (BlockIdentifiers,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/block_identifiers',
                'operation_id': 'get_block_identifiers',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'order',
                    'page_token',
                    'page_size',
                ],
                'required': [
                    'protocol',
                    'network',
                ],
                'nullable': [
                ],
                'enum': [
                    'order',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('order',): {

                        "DESC": "desc",
                        "ASC": "asc"
                    },
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'order':
                        (str,),
                    'page_token':
                        (str,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'order': 'order',
                    'page_token': 'page_token',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'order': 'query',
                    'page_token': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_block_identifiers
        )

        def __get_current_block_hash(
            self,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Get the Current Block Hash  # noqa: E501

            Get the current block id (hash) of the protocol.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_current_block_hash(protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                str
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            return self.call_with_http_info(**kwargs)

        self.get_current_block_hash = _Endpoint(
            settings={
                'response_type': (str,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/sync/block_id',
                'operation_id': 'get_current_block_hash',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                ],
                'required': [
                    'protocol',
                    'network',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_current_block_hash
        )

        def __get_current_block_number(
            self,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Get the Current Block Number  # noqa: E501

            Returns the current block number/height of the protocol.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_current_block_number(protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                int
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            return self.call_with_http_info(**kwargs)

        self.get_current_block_number = _Endpoint(
            settings={
                'response_type': (int,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/sync/block_number',
                'operation_id': 'get_current_block_number',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                ],
                'required': [
                    'protocol',
                    'network',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_current_block_number
        )
